#include "atpgInt.h"
#include "bdd.h"

/*---------------------------------------------------------------------------*/
/* Definition of exported functions                                          */
/*---------------------------------------------------------------------------*/

void Atpg_Run(
	      Ntk_Network_t * network
	      )
{
  Ntk_Node_t *node;
  vertex_t *nodeVertex;
  mdd_manager *mddManager;
  Mvf_Function_t *func;
  mdd_t *mddTemp;
  mdd_t *f, *f_x, *f_xbar, *x;
  graph_t *partition;

  /* Example of array_t initialization */
  array_t *mddArray = array_alloc (mdd_t *, 0);

  /* Example bdd nodes */
  bdd_t *g;
  
  lsGen          gen;
  
  mddManager = Ntk_NetworkReadMddManager (network);
  partition = (graph_t *) Ntk_NetworkReadApplInfo (network, PART_NETWORK_APPL_KEY);

  /*********************COMMENT*****************************/
  /* Look "ntk" package for more information about reading */
  /* nodes from network*************************************/
  /*********************************************************/
  
  Ntk_NetworkForEachPrimaryInput(network, gen, node){
     (void) fprintf (vis_stdout, "Primary input: %s \t MddId: %d \n",
		     Ntk_NodeReadName(node), Ntk_NodeReadMddId(node));
     nodeVertex = Part_PartitionFindVertexByName(partition, Ntk_NodeReadName(node) );
     func = Part_VertexReadFunction(nodeVertex);
     x /*mddTemp*/ = Mvf_FunctionObtainComponent(func, 1);
     /*bdd_print((bdd_t *)mddTemp);*/
     array_insert_last( bdd_t *, mddArray, x);
     (void) fprintf("Array size: %d\n", array_n(mddArray));
  }

  Ntk_NetworkForEachPrimaryOutput(network, gen, node){
     (void) fprintf (vis_stdout, "Primary input: %s \t MddId: %d \n",
		     Ntk_NodeReadName(node), Ntk_NodeReadMddId(node));
     nodeVertex = Part_PartitionFindVertexByName(partition, Ntk_NodeReadName(node) );
     func = Part_VertexReadFunction(nodeVertex);
     mddTemp = Mvf_FunctionObtainComponent(func, 1);
     bdd_print((bdd_t *)mddTemp);
  }
  f_x = bdd_cofactor(mddTemp, x);
  bdd_print_minterm(f_x);

}
