/**CFile***********************************************************************

  FileName    [atpgCmd.c]

  PackageName [atpg]

  Synopsis    [Commands for the atpg package.]

******************************************************************************/

#include "atpgInt.h"
/*---------------------------------------------------------------------------*/
/* Variable declarations                                                     */
/*---------------------------------------------------------------------------*/



/**AutomaticStart*************************************************************/

/*---------------------------------------------------------------------------*/
/* Static function prototypes                                                */
/*---------------------------------------------------------------------------*/
static int CommandRunAtpg (Hrc_Manager_t ** hmgr);//, int argc, char **argv);
   
/**AutomaticEnd***************************************************************/


/*---------------------------------------------------------------------------*/
/* Definition of exported functions                                          */
/*---------------------------------------------------------------------------*/

/**Function********************************************************************

  Synopsis    [Initializes the atpg package.]

  SideEffects []

  SeeAlso     [Atpg_End]

******************************************************************************/
void
Atpg_Init (
)
{
  Cmd_CommandAdd ("atpg", CommandRunAtpg, 0);

  return;
}

void
Atpg_End ()
{

  return;
}

/******************************************************************************/
/*---------------------------------------------------------------------------*/
/* Definition of static functions                                            */
/*---------------------------------------------------------------------------*/

/**Function********************************************************************

  Synopsis    [Invokes the main atpg command.]

******************************************************************************/
static int
CommandRunAtpg (hmgr)//, argc, argv)
     Hrc_Manager_t **hmgr;
     //     int argc;
     //     char **argv;
{
/*    int c, u, b, isDump, isReorder, isFreeBDD, rec_depth_arg; */
/*    int s, cnf_bdd, cnf_ssp; */
/*    char *requirementFName = "", *assignmentFName = ""; */
/*    char *depth = ""; */
/*    FILE *fpi, *fpo; */
   
   Ntk_Network_t *network;
   graph_t *partition;
   

   network = Ntk_HrcManagerReadCurrentNetwork (*hmgr);
   
   /* Check if the network has been read in */
   if (network == NIL (Ntk_Network_t))
   {
      (void) fprintf (vis_stderr, "Network hasnt been read yet !!\n");
      /* return */
      return 1;
   }
   
   /* check to see if there is a partition */
   partition = (graph_t *) Ntk_NetworkReadApplInfo (network, PART_NETWORK_APPL_KEY);
   if (partition == NIL (graph_t))
   {
      (void) fprintf (vis_stderr, "No partition exists, use command build_partition_mdds\n");
      return 1;
   }

   Atpg_Run(network);
   
   return 0;
}
