/**CHeaderFile*****************************************************************

  FileName    [restr.h]

  PackageName [restr]

  Synopsis    [STG restructuring package.]

  Description [This package provides the capability to restructure a
  state transition graph (STG).]

  Author      [Balakrishna Kumthekar <kumtheka@colorado.edu>]

  Copyright [This file was created at the University of Colorado at Boulder.
  The University of Colorado at Boulder makes no warranty about the suitability
  of this software for any purpose.  It is presented on an AS IS basis.]


******************************************************************************/

#ifndef _RESTR
#define _RESTR

/*---------------------------------------------------------------------------*/
/* Nested includes                                                           */
/*---------------------------------------------------------------------------*/
#include "ntm.h"
#include "fsm.h"
#include "part.h"
#include "io.h"
#include "ord.h"
#include "mdd.h"
#include "util.h"
#include "synth.h"

/*---------------------------------------------------------------------------*/
/* Constant declarations                                                     */
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/* Structure declarations                                                    */
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/* Type declarations                                                         */
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/* Variable declarations                                                     */
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/* Macro declarations                                                        */
/*---------------------------------------------------------------------------*/


/**AutomaticStart*************************************************************/

/*---------------------------------------------------------------------------*/
/* Function prototypes                                                       */
/*---------------------------------------------------------------------------*/

EXTERN void Restr_Init(void);
EXTERN void Restr_End(void);

/**AutomaticEnd***************************************************************/

#endif /* _RESTR */
